#include "xbasic_types.h"
#include "xio.h"

#include "xparameters.h"

#define N 9
#define ITER 2000

int send_msg (char *, int);
int send_msg_header (void);
void mywait (void);

char msg_header[3] = { 0x55, 0xff, 0x00 };
char sync[1] = { 0x10 };
char music_left[2] = { 0x51, 0x05 };
char music_right[2] = { 0x51, 0x01 };
char set_go[2] = { 0x21, 0x83 };
char set_stop[2] = { 0x21, 0x43 };
char set_reverse[2] = { 0xe1, 0x03 };
char set_reverse_b[2] = { 0xe1, 0x42 };
char set_reverse_a[2] = { 0xe1, 0x41 };
char set_forward[2] = { 0xe1, 0x83 };
char make_slow[4] = { 0x13, 0x03, 0x02, 0x02 };
char make_fast[4] = { 0x13, 0x03, 0x02, 0x04 };
char last_op = 0x00;
Xuint32 counter = 0;
int lastRegion;
#define ROWTOUSE 1
#define REGION_THRESH 6000
#define SCREENSECTIONS 3
#define FRAMEHEIGHT 240
#define FRAMEWIDTH 320
#define LINES_PER_SECTION (FRAMEHEIGHT/SCREENSECTIONS)

#define LEFT_BORDER 106
#define RIGHT_BORDER 213


int section[SCREENSECTIONS][3];


int start;
int length;
int endpoint;

int max_row;
int max_length;

int line_data[FRAMEHEIGHT];

int count;

int lcount, j, k, l, r;
int m, n;

/* section[SCREENSECTIONS][0]=left
   section[SCREENSECTIONS][1]=middle
   section[SCREENSECTIONS][2]=right
*/



extern Xuint32 line_array[FRAMEHEIGHT];

void
count_pixel ()
{
  lcount = 0;
  j = 0;



  for (n = 0; n < 3; n++)
    {
      for (m = 0; m < SCREENSECTIONS; m++)
	{
	  section[m][n] = 0;
	  section[m][n] = 0;
	  section[m][n] = 0;
	}
    }



  for (j = 0; j < SCREENSECTIONS; j++)
    {				//every time this one finishes we have calculated the pixels in each section of the frame
      for (k = 0; k < LINES_PER_SECTION; k++)
	{			//every time this loop finishes execution we have calculated the amount of pixels per section.


	  //  for(count=0; count<240; count++){
	  //   print("do u come here?");



	  length = line_array[lcount] & 0x0000ffff;
	  start = ((line_array[lcount] & 0xffff0000) >> 16);
	  endpoint = start + length;

	  /*     putnum(line_array[count]);
	     print(" ");
	     putnum(start);
	     print(" ");
	     putnum(length);
	     print("\n\r");
	   */

	  //Calculate # of pixels in left section
	  if (start < 106 && endpoint < 106)
	    {
	      l = length;
	      section[j][0] = length + section[j][0];
	      //left[j] = length + left[j];
	    }
	  else if (start < 106 && endpoint > 106)
	    {
	      l = (106 - start);
	      section[j][0] = (106 - start) + section[j][0];
	      //left[j] = (106 - start) + left[j];
	    }


	  // Calculate # of pixels in right section
	  if (213 < endpoint && 213 < start)
	    {
	      r = length;
	      section[j][2] = length + section[j][2];
	      //right[j] = length + right[j];
	    }
	  else if (213 < endpoint && 213 > start)
	    {
	      r = endpoint - 213;
	      section[j][2] = endpoint - 213 + section[j][2];
	      //right[j] = endpoint - 213 + right[j];
	    }


	  // Calculate the # of pixels in the middle section


	  section[j][1] = section[j][1] + (length - (l + r));


	  l = 0;
	  r = 0;
	  lcount = lcount + 1;
	}			//end for k<lines per section 

      /*
         putnum(j); 
         print(" "); 
         putnum(section[j][0]); 
         print(" ");
         putnum( section[j][1]);     
         print(" "); 
         putnum(section[j][2]);     
         print("\n\r"); 
       */


    }
}				//end count_pixel

movement ()
{

  //go through the first row
  //whichever has the highest value
  //move accordingly

  int i, j;



  int highest_column[3] = { -1, -1, -1 };
  int highest_value[3] = { REGION_THRESH, REGION_THRESH, REGION_THRESH };
  send_msg (make_slow, 4);

  for (j = 0; j < 3; j++)
    {
      for (i = 0; i < 3; i++)
	{
	  if (i == 2)
	    section[j][i] *= 1.4;

	  if (section[j][i] > highest_value[j])
	    {
	      highest_column[j] = i;
	      highest_value[j] = section[j][i];
	    }

	}

    }


//Error, return and do nothing

  for (j = 0; j < 3; j++)
    if (highest_column[j] == 0)
      {
	pt_turn_left ();
	return;
      }
    else if (highest_column[j] == 1)
      {
	forward ();
	return;
      }
    else if (highest_column[j] == 2)
      {
	pt_turn_right ();
	lastRegion = highest_column[j];
	return;
      }
  j = j - 1;
  if(lastRegion == -1){
	
    pt_turn_right();
    forward();
    return;
  } 
  else{
 
  highest_column[2] = lastRegion;
 
  }
}


forward ()
{
  send_msg (set_forward, 2);
  send_msg (set_go, 2);
}

stop ()
{
  send_msg (set_stop, 2);
}

reverse ()
{
  send_msg (set_reverse, 2);
  send_msg (set_go, 2);
}

pt_turn_right ()
{
//      stop();
//      send_msg(music_left,2);
  send_msg (set_forward, 2);
  send_msg (set_reverse_b, 2);
  send_msg (set_go, 2);
}

pt_turn_left ()
{
//      stop();
//      send_msg(music_right,2);
  send_msg (set_forward, 2);
  send_msg (set_reverse_a, 2);
  send_msg (set_go, 2);

}

sync_rcx ()
{

  send_msg (sync, 2);
  send_msg (sync, 2);
  send_msg (music_right, 2);



}

wait ()
{

  int i;

  for (i = 0; i < 1550000; i++)
    i = i;

}

long_wait ()
{

  int i, j;

  for (i = 0; i < 1000000; i++)
    for (j = 0; j < 10; j++)
      j = j;
}

int
send_msg (char *message, int length)
{
  int i;
  char temp = message[0];
  char message_comp, checksum, checksum_comp;

  wait ();
  if (last_op == message[0])
    message[0] = message[0] + 0x08;


  checksum = 0;
  //Send the header
  send_msg_header ();

  //Now lets send the data, each data bit
  //is followed by its compliment and the 
  //checksum is updated

  for (i = 0; i < length; i++)
    {
      XUartLite_SendByte (XPAR_MYUART_BASEADDR, message[i]);
      //wait();
      checksum += message[i];	/*update the checksum */
      message_comp = (~message[i]) & 0xff;	/*get the compliment */
      XUartLite_SendByte (XPAR_MYUART_BASEADDR, message_comp);
      //wait();
    }

  XUartLite_SendByte (XPAR_MYUART_BASEADDR, checksum);
  //wait();
  checksum_comp = (~checksum) & 0xff;
  XUartLite_SendByte (XPAR_MYUART_BASEADDR, checksum_comp);

  message[0] = temp;
  last_op = message[0];
  return 0;
}

int
send_msg_header (void)
{
  int i;
  for (i = 0; i < 2; i++)
    XUartLite_SendByte (XPAR_MYUART_BASEADDR, msg_header[i]);
  return 0;
}
