#include "xbasic_types.h"
#include "xio.h"

#define W 640
#define H 480
#define VGA_START 0x00800000
#define RED 0xE0
#define GREEN 0x1C
#define BLUE 0x03

#define LEFT_B 106
#define RIGHT_B 213

#define VERT_SYNC ((XIo_In32(0x01803FFC) & 0x20))
#define NOT_VERT_SYNC (! (XIo_In32(0x01803FFC) & 0x20))
#define FILLING_LEVEL (XIo_In32(0x01803FFC) & 0x0F)
//#define FRAME_ID XIo_In32(0x01803FFC)
#define LINE_DATA XIo_In32(0x018008FC)
#define STRENGTH XIo_In32(0x01802FFC)
#define LINE_ARRAY_LENGTH 240

#define THRESHOLD 0x53 //day threshold
//#define THRESHOLD 0x51 //night threshold

#define SCREENSECTIONS 3  //make sure this agrees with lightfinder.c



extern void write_video(int start, int end, int line);
extern void set_registers();

extern int section[SCREENSECTIONS][3];

extern void count_pixel();
extern void movement();
extern void sync_rcx();


extern int lastRegion;
extern int last_Block;
Xuint32 line_array[LINE_ARRAY_LENGTH];
Xuint32 strength_array[LINE_ARRAY_LENGTH];
Xuint32 last_strength[LINE_ARRAY_LENGTH];


int main()
{
  Xuint8 bw_1pixel;
  Xuint32 bw_4pixels;
  Xuint32 luma_4pixels;
  Xuint32 current_level;
  int frame_id;
  int line_number = 0;
  int line;
  int start, end;
  int i, j, x;
  int line_section;
  int testframe;
  int length;
  int position;
  int b;
  int framenum;
  int average;
// print("Hello World!\r\n");

  lastRegion = -1;

  microblaze_enable_icache();

  set_registers();
  sync_rcx(); 
  // Clear screen //
  for (i = 0; i < H*W; i++)
    XIo_Out8(VGA_START + i, 0);

  // THis is a delay to ensure that the chip is configured
  for (i=0; i<10000000;i++);

  line = 0;
  testframe = 0;
  framenum = 0;


  XIo_Out32(0x01802FFC, THRESHOLD);
  
  /*Top while loop returns us to grab another frame after we do some processing*/
  while (1){
    
    //This while loop grabs a whole screen/frame of video and then lets us out to process it if we wish
    while (line<239){                           //  while (line<239 && framenum == 0) {
      
      while (VERT_SYNC);
      // Wait for the vertical synchronism
      while (NOT_VERT_SYNC);
      
      line = -1;        
      
            
      while (1)
	{
	  line = line + 1;
	  
	  // This variable indicates how much of //
	  // the current line has  been  already //
	  // written into the block RAMs         //
	  current_level = 0x0001;
	  
	  for (line_section = 0; line_section < 4; line_section++)
	    {
	      // Wait for the current line to be  1/4,  1/2,  3/4 //
	      // and full filled. The while then executes 4 times //
	      while (!(FILLING_LEVEL & current_level))
		{
		  if (NOT_VERT_SYNC)
		    break;
		}
	      
	      /*  if (current_level == 0x01) { */
	      /* 		start = 0; */
	      /* 		end = 160; */
	      /* 	      } */
	      /* 	      else if (current_level == 0x02) { */
	      /* 		start = 160; */
	      /* 		end = 320; */
	      /* 	      } */
	      /* 	      else if (current_level == 0x04) { */
	      /* 		start = 320; */
	      /* 		end = 480; */
	      /* 	      } */
	      if (current_level == 0x08) {  //was originally an else if
		start = 480;
		end = 640;
		line_array[line] = LINE_DATA;
	      }
	      
	      if (NOT_VERT_SYNC)
		break;
	      
	      //      write_video(start, end, line);
	      
	      current_level = current_level << 1;
	      
	      if (NOT_VERT_SYNC)
		break;
	    }
	  
	  if (NOT_VERT_SYNC)
	    break;
	}
    }
    
    
    for(i=241; i<480; i++){
      position = (line_array[i-240]>>16) & 0xFFFF;
      length = line_array[i-240] & 0xFFFF;
      for(j=0; j<position && j<320; j++){
	XIo_Out8 (VGA_START +i*W + j, 0xFF);
      }
      for(j=position;j<position+length && j<320;j++){
	XIo_Out8 (VGA_START +i*W + j, 0x00);
      }
      for(j=position+length;j<320;j++)
	XIo_Out8 (VGA_START +i*W + j, 0xFF);
      XIo_Out8(VGA_START +i*W+LEFT_B, GREEN);
      XIo_Out8(VGA_START +i*W+RIGHT_B, GREEN);
    }
    
    
    count_pixel();           //                                    PUT THIS BACK IN!!!!
    movement();
    
    
    line = -1;
    
  } //while (1)
  
  
  return 0;
}
